interface SellerServiceInterface {
  RequestResponse: getPrice, getProducts, getPaymentMethods, getDiscountedPrice
}

inputPort In {
  Location: "socket://localhost:8000"
  Protocol: sodep
  Interfaces: SellerServiceInterface
}

outputPort Self{
  Location: "socket://localhost:8000"
  Protocol: sodep
  Interfaces: SellerServiceInterface
}
// comment
execution{ concurrent }

init
{
  p.( "Through the Looking-Glass, and What Humpty Dumpty Found There" ) = 12;
  p.( "Cheshire Cat's Adventures in Wonderland" ) = 15;
  p.( "Jabberwocky" ) = 10;

  pay[0] = "Visa";
  pay[1] = "Wire";
  pay[2] = "PayPal";

  cardId.( "31415" ) = 0.10
}

main
{
  [ getProducts( request )( response ){
  	foreach (c : p) {
  		response = response + "\n" + c
  	}
  }]{ nullProcess }

  [ getPrice( request )( response ){
    if( is_defined( p.( request.p[0] ) ) ){
    	response = p.( request.p[0] )
    } else {
    	response = "Item not in stock"
    }
  }]{ nullProcess }

  [ getPaymentMethods( request )( response ){
    for( i = 0, i < #pay, i++ ){
    	response = response + "\n" + pay[ i ]
    }
  }]{ nullProcess }
  
  [ getDiscountedPrice( request )( response ){
		getPrice@Self( request )( response );
		if( response instanceof double && is_defined( cardId.( request.p[1] ) ) ){
			response = double( response ) * ( double( 1 ) - cardId.( request.p[1] ) )
		}
  }]{ nullProcess }
}